//====================================================
// Map.H
//
// The Nipples World Map (symbols and types)
//
// ZNibbles
// Vincent Mallet 1997, 1998
//====================================================

// $Id: Map.H,v 1.3 1999/04/03 23:54:21 vmallet Exp $

/* ZNibbles - a small multiplayer game
 * Copyright (C) 1997, 1998, 1999 Vincent Mallet - vmallet@enst.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __MAP_H__
#define __MAP_H__

 #include <stdlib.h>

#include "DLList.h" // Doubly linked lists

enum { MT_UNGETTABLE, MT_GETTABLE };

class _Object;
class NibblesArea;

typedef _Object * MapType;

typedef DLList<_Object*> TypeList;

class Map {

  friend NibblesArea;

public:

  Map();
  ~Map();

  void make(int x, int y);

  void clear(int c = '.');
  void draw_number(int x, int y, int val);
  void draw_point(int x, int y, int ch);

  void add_type(int x, int y, _Object &obj);
  TypeList & get_type(int x, int y);
  
  void display();
  void display_t();
  
private:
  int    _x;
  int    _y;
  char ** _map;

  DLList<MapType> ** _maptype;


}; // class Map


inline Map::Map() : _x(0), _y(0), _map(NULL), _maptype(NULL) { }

#endif // __MAP_H__
